NX Open C++ Reference Guide
|
Represents a Dynamic Section Builder used for creating sections. More...
Public Member Functions | |
void | AlternatePlane () |
Cycle through planes that are 90 degrees aligned to the current section plane. | |
NXOpen::NXColor * | CapColor () |
Returns the cap color. | |
NXOpen::Display::DynamicSectionTypes::CapColorOption | CapColorOption () |
Returns the cap color option Created in NX5.0.0. | |
NXOpen::Display::DynamicSectionTypes::Clip | ClipType () |
Returns the clip type Created in NX5.0.0. | |
NXOpen::DatumPlane * | CreateDatumPlane () |
Creates a datum plane from the active section plane. | |
NXOpen::Display::DynamicSectionTypes::CoordinateSystem | CsysType () |
Returns the coordinate system used for creating section plane along X, Y or Z principal planes. | |
NXOpen::NXColor * | CurveColor () |
Returns the curve color. | |
NXOpen::Display::DynamicSectionTypes::CurveColorOption | CurveColorOption () |
Returns the curve color option Created in NX5.0.0. | |
bool | DeferCurveUpdate () |
Returns the defer curve update property. | |
void | EditView (NXOpen::ModelingView *view) |
Edits the section object in the modeling view. | |
void | GetActivePlane (NXOpen::Display::DynamicSectionTypes::Axis *planeAxis, NXOpen::Display::DynamicSectionTypes::ActivePlane *activePlane) |
Gets the active plane in the section. | |
NXOpen::Display::PlaneGridBuilder * | GetGridSettings () |
Creates a grid settings builder from the active section plane. | |
NXString | GetName () |
Gets the section name. | |
NXOpen::Vector3d | GetNormal () |
Gets the normal of the section plane. | |
double | GetOffset () |
Gets the the plane offset. | |
void | GetOffsetLimits (double *minimumOffset, double *maximumOffset) |
Gets minimum and maximum offset limits. | |
NXOpen::Point3d | GetOrigin () |
Gets the section origin. | |
double | GetPlaneThickness () |
Gets the thickness between active plane pair. | |
double | GetRotationAngle (NXOpen::Display::DynamicSectionTypes::Axis rotationAxis) |
Gets rotation angle for specified axis. | |
NXOpen::Matrix3x3 | GetRotationMatrix () |
Gets the section rotation matrix. | |
NXOpen::NXColor * | InterferenceColor () |
Returns the interference color. | |
bool | IsAssociativitySupported () |
Determines if an associative section plane is supported. | |
NXOpen::Display::LayerSettingsBuilder * | LayerSettings () |
Returns the layer settings builder. | |
bool | LoadAllIntersecting (NXOpen::PartLoadStatus **loadStatus) |
Loads all components that intersect the current section plane. | |
bool | LoadNearIntersecting (NXOpen::PartLoadStatus **loadStatus) |
Loads components that intersect the current section plane and are near the section plane origin. | |
bool | LockPlanes () |
Returns the lock planes flag. | |
int | NumberInSeries () |
Returns the number of requested section planes in the current section series. | |
void | OffsetOriginInPlane (double xOffset, double yOffset) |
Offsets section origin within current section plane. | |
void | PlaneX () |
Creates a plane along X direction. | |
void | PlaneY () |
Creates a plane along Y direction. | |
void | PlaneZ () |
Creates a plane along Z direction. | |
void | RestoreView () |
Restores the section to the saved section in the view database. | |
void | ReverseDirection () |
Reverses the plane direction. | |
bool | ReverseSeries () |
Returns the reverse series flag Created in NX6.0.0. | |
void | SaveCurves (const NXString &groupName) |
Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name. | |
void | SaveCurves (const char *groupName) |
Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name. | |
double | SeriesSpacing () |
Returns the section plane spacing in the current section series. | |
void | SetActivePlane (NXOpen::Display::DynamicSectionTypes::Axis planeAxis, NXOpen::Display::DynamicSectionTypes::ActivePlane activePlane) |
Sets the active plane in the section. | |
void | SetAssociativePlane (NXOpen::Plane *planeTag) |
Makes dynamic section associative to the specified plane The plane must be a smart plane; otherwise an error will be reported. | |
void | SetCapColor (NXOpen::NXColor *capColor) |
Sets the cap color. | |
void | SetCapColorOption (NXOpen::Display::DynamicSectionTypes::CapColorOption capColorOption) |
Sets the cap color option Created in NX5.0.0. | |
void | SetClipType (NXOpen::Display::DynamicSectionTypes::Clip clipType) |
Sets the clip type Created in NX5.0.0. | |
void | SetCsysType (NXOpen::Display::DynamicSectionTypes::CoordinateSystem csys) |
Sets the coordinate system used for creating section plane along X, Y or Z principal planes. | |
void | SetCurveColor (NXOpen::NXColor *curveColor) |
Sets the curve color. | |
void | SetCurveColorOption (NXOpen::Display::DynamicSectionTypes::CurveColorOption curveColorOption) |
Sets the curve color option Created in NX5.0.0. | |
void | SetDefaultPlane () |
Set current section plane to its default definition. | |
void | SetDefaults () |
Set current section to the default values. | |
void | SetDeferCurveUpdate (bool deferCurveUpdate) |
Sets the defer curve update property. | |
void | SetInterferenceColor (NXOpen::NXColor *interferenceColor) |
Sets the interference color. | |
void | SetLockPlanes (bool lockPlanes) |
Sets the lock planes flag. | |
bool | SetName (const NXString §ionName) |
Sets the section name. | |
bool | SetName (const char *sectionName) |
Sets the section name. | |
void | SetNormal (const NXOpen::Vector3d &normal) |
Sets the normal of the section plane Section offset and rotation matrix are updated. | |
void | SetNumberInSeries (int numberSectionsRequested) |
Sets the number of requested section planes in the current section series. | |
void | SetOffset (double offset) |
Sets the the plane offset. | |
void | SetOffsetByPoint (const NXOpen::Point3d &point) |
This method offsets the active clipping plane such that the plane passes through the specified point. | |
void | SetOrigin (const NXOpen::Point3d &origin) |
Sets the section origin. | |
void | SetPlane (const NXOpen::Point3d &axisOrigin, const NXOpen::Point3d &origin, const NXOpen::Matrix3x3 &rotationMatrix) |
Sets a section plane to be the specified plane The plane is created at the specified origin with the specified rotation matrix. | |
void | SetPlaneThickness (double planeThickness) |
Sets the thickness between active plane pair. | |
void | SetReverseSeries (bool reverseSeries) |
Sets the reverse series flag Created in NX6.0.0. | |
void | SetRotationAngle (NXOpen::Display::DynamicSectionTypes::Axis rotationAxis, double angle) |
Rotates the section about specified axis by the specified angle. | |
void | SetRotationMatrix (NXOpen::Display::DynamicSectionTypes::Axis rotationAxis, const NXOpen::Matrix3x3 &rotationMatrix) |
Sets the section rotation matrix Specify Display::DynamicSectionTypes::AxisNone if the axis about which rotation was performed is not known. | |
void | SetSeriesSpacing (double sectionSpacing) |
Sets the section plane spacing in the current section series. | |
void | SetShowCap (bool showCap) |
Sets the cap on off flag Created in NX5.0.0. | |
void | SetShowClip (bool showClip) |
Sets the clip on off flag Created in NX5.0.0. | |
void | SetShowCurves (bool showCurves) |
Sets the curve on off flag. | |
void | SetShowGrid (bool showGrid) |
Sets the show grid display flag Created in NX6.0.0. | |
void | SetShowInterference (bool showInterference) |
Sets the interference on off flag. | |
void | SetShowViewer (bool showViewer) |
Sets the 2D viewer display flag Created in NX6.0.0. | |
void | SetType (NXOpen::Display::DynamicSectionTypes::Type type) |
Sets the section type Created in NX5.0.0. | |
void | SetView (NXOpen::ModelingView *view) |
Sets the modeling view in which section object edits are being done. | |
bool | ShowCap () |
Returns the cap on off flag Created in NX5.0.0. | |
bool | ShowClip () |
Returns the clip on off flag Created in NX5.0.0. | |
bool | ShowCurves () |
Returns the curve on off flag. | |
bool | ShowGrid () |
Returns the show grid display flag Created in NX6.0.0. | |
bool | ShowInterference () |
Returns the interference on off flag. | |
void | ShowSectionCurves (bool showCurves) |
Shows the section curves in the view associated with the builder. | |
bool | ShowViewer () |
Returns the 2D viewer display flag Created in NX6.0.0. | |
NXOpen::Display::DynamicSectionTypes::Type | Type () |
Returns the section type Created in NX5.0.0. | |
NXOpen::ModelingView * | View () |
Returns the modeling view in which section object edits are being done. | |
![]() | |
NXOpen::NXObject * | Commit () |
Commits any edits that have been applied to the builder. | |
void | Destroy () |
Deletes the builder, and cleans up any objects created by the builder. | |
std::vector< NXOpen::NXObject * > | GetCommittedObjects () |
For builders that create more than one object, this method returns the objects that are created by commit. | |
NXOpen::NXObject * | GetObject () |
Returns the object currently being edited by this builder. | |
void | ShowResults () |
Updates the model to reflect the result of an edit to the model for all builders that support showing results. | |
virtual bool | Validate () |
Validate whether the inputs to the component are sufficient for commit to be called. | |
![]() | |
tag_t | GetTag () const |
<b>Deprecated</b>:<br> Use Tag instead. | |
tag_t | Tag () const |
Returns the tag of this object. | |
Represents a Dynamic Section Builder used for creating sections.
<br> The dynamic sectioning is performed on a displayable part that is displayed in the modeling work view.It is possible to specify the view after creating the builder. However, the specified view must be modeling work view. This operation is meant to be performed in an interactive mode with visual feedback. <br> <br> <b>Builder Creation:</b> <br> <br> The dynamic section builder can be used to create new dynamic section objects OR to edit an existing section object. See @link Display::DynamicSectionCollection::CreateSectionBuilder Display::DynamicSectionCollection::CreateSectionBuilder@endlink When a view is specified during the builder creation, the dynamic section object will be activated in the view. When the dynamic section object is activated in the view, view clipping and capping is enabled. However, it is not necessary to specify the view. <br> <br> There are three different types of sections that are currently being supported. <br> <br> <ul> <li>One Plane Section</li> <li>Two Parallel Planes Section</li> <li>Box Section</li> </ul> <br> <br> User can switch between these types at any time. <br> <br> <b>Assembly and Modeling Operations</b> <br> <br> <ul> <li>Create section curves by intersecting all clipping planes with all bodies in the scene</li> <li>Create a datum plane from the active section plane.</li> <li>Load components that are near or intersecting with the active section plane.</li> </ul> <br> <br> All the APIs accept geometric data such as plane origin, plane normal in the absolute coordinate system. <br> <br> <b>Saving changes</b> <br> <br> @link Builder::Commit Builder::Commit@endlink method will activate the section object in the modeling view. It returns the dynamic section object tag. <br> <br> <b>Section Plane Families:</b> <br> <br> An important issue with dynamic sectioning is the ability to easily define a group of related cross-section planes. A group of related cross-section planes will be known as a <tt>Plane Family</tt>. An important idea in understanding a plane family is the concept of a defining or a <tt>Base Plane</tt>. The base plane of the plane family is the starting point (i.e. plane) for the plane family. All planes in the family are related by an offset to the base plane. There are two types of plane families: <br> <br> <ul> <li>Linear</li> <li>Axi-Symmetric</li> </ul> <br> <br> <tt>Linear Plane Family</tt> <br> <br> A linear plane family is defined by an infinite group of parallel planes. All of the planes in a linear family are parallel to its base plane (i.e. along the base plane normal at some linear offset value). This is illustrated below with a base plane and three parallel planes to it that are members of the plane family. <br> <br> Base Plane <br> @code | | | | | | | | | | | | ==\> Nomal to all planes. | | | | | | | | @endcode <br> <tt>Axi-Symmetric Plane Family</tt> <br> <br> An axi-symmetric plane family is defined by rotating the base plane about one of the three primary axes. There are an infinite number of planes in an axi-symmetric plane family similar to a linear plane family. This is illustrated below with a base plane and three planes rotated about the z-axis. <br> @code \ | / \ | / \ | / \|/____ Base Plane @endcode <br> <b>Switching between plane families</b> <br> <br> Methods defining a new linear family <br> <br> <ul> <li>@link Display::DynamicSectionBuilder::AlternatePlane Display::DynamicSectionBuilder::AlternatePlane@endlink </li> <li>@link Display::DynamicSectionBuilder::PlaneX Display::DynamicSectionBuilder::PlaneX@endlink </li> <li>@link Display::DynamicSectionBuilder::PlaneY Display::DynamicSectionBuilder::PlaneY@endlink </li> <li>@link Display::DynamicSectionBuilder::PlaneZ Display::DynamicSectionBuilder::PlaneZ@endlink </li> <li>@link Display::DynamicSectionBuilder::SetNormal Display::DynamicSectionBuilder::SetNormal@endlink </li> <li>@link Display::DynamicSectionBuilder::SetOffset Display::DynamicSectionBuilder::SetOffset@endlink </li> <li>@link Display::DynamicSectionBuilder::SetOffsetByPoint Display::DynamicSectionBuilder::SetOffsetByPoint@endlink </li> <li>@link Display::DynamicSectionBuilder::SetOrigin Display::DynamicSectionBuilder::SetOrigin@endlink </li> <li>@link Display::DynamicSectionBuilder::SetPlane Display::DynamicSectionBuilder::SetPlane@endlink </li> </ul> <br> <br> Following methods define a new axi-symmetric family <br> <br> <ul> <li>@link Display::DynamicSectionBuilder::SetRotationAngle Display::DynamicSectionBuilder::SetRotationAngle@endlink </li> <li>@link Display::DynamicSectionBuilder::SetRotationMatrix Display::DynamicSectionBuilder::SetRotationMatrix@endlink </li> </ul> <br> <br> <b>Transition between plane families</b> <br> <br> When a method defining a new linear family is invoked, then if <br> <br> <ul> <li>the current plane is in a linear family, it will stay in the family.</li> <li>the current plane is in a axi-symmetric family, it becomes the base plane of the linear family.</li> </ul> <br> <br> The same thing happens when a method defining a new axi-symmetric plane is invoked. <br> <br> <b>Examples:</b> <br> <br> <tt>1. Linear Family</tt> <br> <br> Goal: User wants to create a series of sections along X axis. <br> <br> API sequence: <br> @code planeX - Create a plane with base plane at X = 0 See Display.DynamicSectionBuilder.PlaneX SetOffset( 50 ) - Plane at X = 50 SetOffset( 100 ) - Plane at X = 100 SetOffset( 0 ) - Plane at X = 0 @endcode <br> <tt>2. Axi-symmetric Family</tt> <br> <br> Goal: User wants to create a series of sections by planes rotated around X axis of the section plane. <br> <br> API sequence: <br> @code SetRotation( X, 45 ) - The current plane becomes base plane. Then the plane rotated around X axis by 45 degrees. SetRotation( X, 90 ) - Plane rotated around X axis by 90 degrees. SetRotation( X, 90 ) - Plane rotated around X axis by 0 degrees. Back to original position. @endcode
Default values.
Property | Value |
---|---|
CapColorOption |
Any |
ClipType | |
CurveColorOption |
Any |
LayerSettings.LayerOption |
Work |
LockPlanes |
true |
ShowCap |
true |
ShowClip |
true |
ShowCurves (deprecated) |
false |
ShowGrid |
false |
ShowInterference |
false |
ShowViewer |
false |
Type |
OnePlane |
Created in NX5.0.0.
void NXOpen::Display::DynamicSectionBuilder::AlternatePlane | ( | ) |
Cycle through planes that are 90 degrees aligned to the current section plane.
For example, for a XY plane with normal along positive Z axis, invoking this method will cycle through the planes in the following order. @code - YZ plane with normal along X axis - XZ plane with normal along Y axis - XY plane with normal along Z axis @endcode The section offset and rotation matrix are updated.
Created in NX5.0.0.
License requirements : None
NXOpen::NXColor* NXOpen::Display::DynamicSectionBuilder::CapColor | ( | ) |
Returns the cap color.
Used when cap color type is Display::DynamicSectionTypes::CapColorOptionAny
Created in NX5.0.0.
License requirements : None
NXOpen::Display::DynamicSectionTypes::CapColorOption NXOpen::Display::DynamicSectionBuilder::CapColorOption | ( | ) |
Returns the cap color option
Created in NX5.0.0.
License requirements : None
NXOpen::Display::DynamicSectionTypes::Clip NXOpen::Display::DynamicSectionBuilder::ClipType | ( | ) |
Returns the clip type
Created in NX5.0.0.
License requirements : None
NXOpen::DatumPlane* NXOpen::Display::DynamicSectionBuilder::CreateDatumPlane | ( | ) |
Creates a datum plane from the active section plane.
NXOpen::Display::DynamicSectionTypes::CoordinateSystem NXOpen::Display::DynamicSectionBuilder::CsysType | ( | ) |
Returns the coordinate system used for creating section plane along X, Y or Z principal planes.
Created in NX5.0.0.
License requirements : None
NXOpen::NXColor* NXOpen::Display::DynamicSectionBuilder::CurveColor | ( | ) |
Returns the curve color.
Used when the curve color option is set to Display::DynamicSectionTypes::CurveColorOptionAny .
Created in NX5.0.0.
License requirements : None
NXOpen::Display::DynamicSectionTypes::CurveColorOption NXOpen::Display::DynamicSectionBuilder::CurveColorOption | ( | ) |
Returns the curve color option
Created in NX5.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::DeferCurveUpdate | ( | ) |
Returns the defer curve update property.
This property can be used to reduce number of curve updates when performing a series of attribute changes on the dynamic section. After the changes are done, undefer the curve update. Undeferring will update the curves, if and only if, curve update is required based on the applied changes.
Created in NX8.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::EditView | ( | NXOpen::ModelingView * | view | ) |
Edits the section object in the modeling view.
<br> The view being edited must be the modeling view. This is provided to handle scenarios when the working view is changed when sectioning is in progress. It is the responsibility of user to save pending changes using @link Builder::Commit Builder::Commit@endlink method. Otherwise, any existing changes will be lost. <br>
Created in NX6.0.0.
License requirements : None
view | Modeling view |
void NXOpen::Display::DynamicSectionBuilder::GetActivePlane | ( | NXOpen::Display::DynamicSectionTypes::Axis * | planeAxis, |
NXOpen::Display::DynamicSectionTypes::ActivePlane * | activePlane | ||
) |
Gets the active plane in the section.
See Display::DynamicSectionBuilder::SetActivePlane for details.
Created in NX5.0.0.
License requirements : None
planeAxis | planeaxis |
activePlane | activeplane |
NXOpen::Display::PlaneGridBuilder* NXOpen::Display::DynamicSectionBuilder::GetGridSettings | ( | ) |
Creates a grid settings builder from the active section plane.
NXString NXOpen::Display::DynamicSectionBuilder::GetName | ( | ) |
Gets the section name.
Caller is expected to free the memory.
NXOpen::Vector3d NXOpen::Display::DynamicSectionBuilder::GetNormal | ( | ) |
Gets the normal of the section plane.
double NXOpen::Display::DynamicSectionBuilder::GetOffset | ( | ) |
Gets the the plane offset.
void NXOpen::Display::DynamicSectionBuilder::GetOffsetLimits | ( | double * | minimumOffset, |
double * | maximumOffset | ||
) |
Gets minimum and maximum offset limits.
<br> Offset limits are dependent on the active section plane. They are determined based on the model bounding box and location of the active section plane. <br> <br> @link Display::DynamicSectionBuilder::SetOffset Display::DynamicSectionBuilder::SetOffset@endlink can specify offset outside the offset limits. In that case the offset limits are extended to include the specified offset. <br>
Created in NX5.0.0.
License requirements : None
minimumOffset | Minimum offset |
maximumOffset | Minimum offset |
NXOpen::Point3d NXOpen::Display::DynamicSectionBuilder::GetOrigin | ( | ) |
Gets the section origin.
double NXOpen::Display::DynamicSectionBuilder::GetPlaneThickness | ( | ) |
Gets the thickness between active plane pair.
This is valid when the section contains more than one clipping plane. When the section planes are locked, setting thickness will not alter the current thickness.
double NXOpen::Display::DynamicSectionBuilder::GetRotationAngle | ( | NXOpen::Display::DynamicSectionTypes::Axis | rotationAxis | ) |
Gets rotation angle for specified axis.
rotationAxis | rotationaxis |
NXOpen::Matrix3x3 NXOpen::Display::DynamicSectionBuilder::GetRotationMatrix | ( | ) |
Gets the section rotation matrix.
NXOpen::NXColor* NXOpen::Display::DynamicSectionBuilder::InterferenceColor | ( | ) |
Returns the interference color.
Created in NX5.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::IsAssociativitySupported | ( | ) |
Determines if an associative section plane is supported.
@return
Created in NX9.0.0.
License requirements : None
NXOpen::Display::LayerSettingsBuilder* NXOpen::Display::DynamicSectionBuilder::LayerSettings | ( | ) |
Returns the layer settings builder.
Created in NX9.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::LoadAllIntersecting | ( | NXOpen::PartLoadStatus ** | loadStatus | ) |
Loads all components that intersect the current section plane.
Errors are reported by the part load status. Caller is expected to destroy the memory used by load status object.
loadStatus | Errors occurred during loading of parts. |
bool NXOpen::Display::DynamicSectionBuilder::LoadNearIntersecting | ( | NXOpen::PartLoadStatus ** | loadStatus | ) |
Loads components that intersect the current section plane and are near the section plane origin.
The distance used for which components are "near" the section plane origin is determined internally. Errors are reported by the part load status. Caller is expected to destroy the memory used by load status object.
loadStatus | Errors occurred during loading of parts. |
bool NXOpen::Display::DynamicSectionBuilder::LockPlanes | ( | ) |
Returns the lock planes flag.
The planes can be locked in case of Two Parallel Planes and Box Section. When locked the planes will move together.
Created in NX5.0.0.
License requirements : None
int NXOpen::Display::DynamicSectionBuilder::NumberInSeries | ( | ) |
Returns the number of requested section planes in the current section series.
Created in NX6.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::OffsetOriginInPlane | ( | double | xOffset, |
double | yOffset | ||
) |
Offsets section origin within current section plane.
<br> The section is moved to new location along in the section plane. The offsets are w.r.t. current origin along the X and Y axis of the section plane respectively. <br>
Created in NX5.0.0.
License requirements : None
xOffset | Delta X from the current position |
yOffset | Delta Y from the current position |
void NXOpen::Display::DynamicSectionBuilder::PlaneX | ( | ) |
Creates a plane along X direction.
<br> The plane is created with the base plane at the origin with normal along X axis of the coordinate system @link Display::DynamicSectionBuilder::CsysType Display::DynamicSectionBuilder::CsysType @endlink and @link Display::DynamicSectionBuilder::SetCsysType Display::DynamicSectionBuilder::SetCsysType @endlink . <br> <br> The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box. <br> <br> Section offset and rotation matrix are updated. <br> <br> Section thickness is recomputed based on the bounding box. <br>
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::PlaneY | ( | ) |
Creates a plane along Y direction.
<br> The plane is created with the base plane at the origin with normal along Y axis of the coordinate system @link Display::DynamicSectionBuilder::CsysType Display::DynamicSectionBuilder::CsysType @endlink and @link Display::DynamicSectionBuilder::SetCsysType Display::DynamicSectionBuilder::SetCsysType @endlink . <br> <br> The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box. <br> <br> Section offset and rotation matrix are updated. <br> <br> Section thickness is recomputed based on the bounding box. <br>
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::PlaneZ | ( | ) |
Creates a plane along Z direction.
<br> The plane is created with the base plane at the origin with normal along Z axis of the coordinate system @link Display::DynamicSectionBuilder::CsysType Display::DynamicSectionBuilder::CsysType @endlink and @link Display::DynamicSectionBuilder::SetCsysType Display::DynamicSectionBuilder::SetCsysType @endlink . <br> <br> The location of the plane depends on the bounding box of all parts displayed in the view. The plane is positioned at the center of the bounding box. <br> <br> Section offset and rotation matrix are updated. <br> <br> Section thickness is recomputed based on the bounding box. <br>
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::RestoreView | ( | ) |
Restores the section to the saved section in the view database.
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::ReverseDirection | ( | ) |
Reverses the plane direction.
This will flip the side of the model being clipped.
Section rotation matrix is updated.
Created in NX5.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::ReverseSeries | ( | ) |
Returns the reverse series flag
Created in NX6.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::SaveCurves | ( | const NXString & | groupName | ) |
Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name.
The group is displayed in the part navigator. If the customer default "Load Solids/Sheets when Saving Section Curves" is enabled, then this will load exact solid/sheet bodies for the visible lightweight bodies intersecting the clipping planes. This may increase the time and memory used by the operation, but will ensure exact section curves.
Created in NX5.0.0.
License requirements : None
groupName | Name of the group containing curves NOTE: The full Unicode character set is not supported for this parameter. |
void NXOpen::Display::DynamicSectionBuilder::SaveCurves | ( | const char * | groupName | ) |
Creates curves by intersecting all clipping planes of the section with all visible bodies in the scene and adds them to the group created with the specified name.
The group is displayed in the part navigator. If the customer default "Load Solids/Sheets when Saving Section Curves" is enabled, then this will load exact solid/sheet bodies for the visible lightweight bodies intersecting the clipping planes. This may increase the time and memory used by the operation, but will ensure exact section curves.
Created in NX5.0.0.
License requirements : None
groupName | Name of the group containing curves NOTE: The full Unicode character set is not supported for this parameter. |
double NXOpen::Display::DynamicSectionBuilder::SeriesSpacing | ( | ) |
Returns the section plane spacing in the current section series.
Created in NX6.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::SetActivePlane | ( | NXOpen::Display::DynamicSectionTypes::Axis | planeAxis, |
NXOpen::Display::DynamicSectionTypes::ActivePlane | activePlane | ||
) |
Sets the active plane in the section.
<br> Single Plane: <br> <br> There is no secondary plane. Only primary plane exists. <br> <br> Two Parallel Plane Section: <br> <br> @link Display::DynamicSectionTypes::AxisZ Display::DynamicSectionTypes::AxisZ@endlink is the active axis and primary/secondary plane can be activated. <br> <br> Box Section: <br> <br> The active plane pair can be selected by specifying the planeAxis Given an axis, the primary/secondary planes can be activated. <br> <br> E.g. To activate primary plane along the local X axis use @link Display::DynamicSectionTypes::AxisX Display::DynamicSectionTypes::AxisX@endlink and @link Display::DynamicSectionTypes::ActivePlanePrimary Display::DynamicSectionTypes::ActivePlanePrimary@endlink . <br>
Created in NX5.0.0.
License requirements : None
planeAxis | planeaxis |
activePlane | activeplane |
void NXOpen::Display::DynamicSectionBuilder::SetAssociativePlane | ( | NXOpen::Plane * | planeTag | ) |
Makes dynamic section associative to the specified plane The plane must be a smart plane; otherwise an error will be reported.
<br> Associative plane can be specified only if the builder supports associativity (see @link Display::DynamicSectionBuilder::IsAssociativitySupported Display::DynamicSectionBuilder::IsAssociativitySupported@endlink ). <br>
Created in NX9.0.0.
License requirements : None
planeTag | Tag of the plane |
void NXOpen::Display::DynamicSectionBuilder::SetCapColor | ( | NXOpen::NXColor * | capColor | ) |
Sets the cap color.
Used when cap color type is Display::DynamicSectionTypes::CapColorOptionAny
Created in NX5.0.0.
License requirements : None
capColor | capcolor |
void NXOpen::Display::DynamicSectionBuilder::SetCapColorOption | ( | NXOpen::Display::DynamicSectionTypes::CapColorOption | capColorOption | ) |
Sets the cap color option
Created in NX5.0.0.
License requirements : None
capColorOption | capcoloroption |
void NXOpen::Display::DynamicSectionBuilder::SetClipType | ( | NXOpen::Display::DynamicSectionTypes::Clip | clipType | ) |
Sets the clip type
Created in NX5.0.0.
License requirements : None
clipType | cliptype |
void NXOpen::Display::DynamicSectionBuilder::SetCsysType | ( | NXOpen::Display::DynamicSectionTypes::CoordinateSystem | csys | ) |
Sets the coordinate system used for creating section plane along X, Y or Z principal planes.
Created in NX5.0.0.
License requirements : None
csys | csys |
void NXOpen::Display::DynamicSectionBuilder::SetCurveColor | ( | NXOpen::NXColor * | curveColor | ) |
Sets the curve color.
Used when the curve color option is set to Display::DynamicSectionTypes::CurveColorOptionAny .
Created in NX5.0.0.
License requirements : None
curveColor | curvecolor |
void NXOpen::Display::DynamicSectionBuilder::SetCurveColorOption | ( | NXOpen::Display::DynamicSectionTypes::CurveColorOption | curveColorOption | ) |
Sets the curve color option
Created in NX5.0.0.
License requirements : None
curveColorOption | curvecoloroption |
void NXOpen::Display::DynamicSectionBuilder::SetDefaultPlane | ( | ) |
Set current section plane to its default definition.
This will only modify section plane geometry.
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::SetDefaults | ( | ) |
Set current section to the default values.
This will modify all section geometry as well as section attributes.
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::SetDeferCurveUpdate | ( | bool | deferCurveUpdate | ) |
Sets the defer curve update property.
This property can be used to reduce number of curve updates when performing a series of attribute changes on the dynamic section. After the changes are done, undefer the curve update. Undeferring will update the curves, if and only if, curve update is required based on the applied changes.
Created in NX8.0.0.
License requirements : None
deferCurveUpdate | defercurveupdate |
void NXOpen::Display::DynamicSectionBuilder::SetInterferenceColor | ( | NXOpen::NXColor * | interferenceColor | ) |
Sets the interference color.
Created in NX5.0.0.
License requirements : None
interferenceColor | interferencecolor |
void NXOpen::Display::DynamicSectionBuilder::SetLockPlanes | ( | bool | lockPlanes | ) |
Sets the lock planes flag.
The planes can be locked in case of Two Parallel Planes and Box Section. When locked the planes will move together.
Created in NX5.0.0.
License requirements : None
lockPlanes | lockplanes |
bool NXOpen::Display::DynamicSectionBuilder::SetName | ( | const NXString & | sectionName | ) |
Sets the section name.
<br> The specified name will be validated. A section is expected to have a unique name in a part. The name may be modified to make it unique within the part. <br> @return If specified name was modified to ensure uniqueness
Created in NX6.0.0.
License requirements : None
sectionName | Section name |
bool NXOpen::Display::DynamicSectionBuilder::SetName | ( | const char * | sectionName | ) |
Sets the section name.
<br> The specified name will be validated. A section is expected to have a unique name in a part. The name may be modified to make it unique within the part. <br> @return If specified name was modified to ensure uniqueness
Created in NX6.0.0.
License requirements : None
sectionName | Section name |
void NXOpen::Display::DynamicSectionBuilder::SetNormal | ( | const NXOpen::Vector3d & | normal | ) |
void NXOpen::Display::DynamicSectionBuilder::SetNumberInSeries | ( | int | numberSectionsRequested | ) |
Sets the number of requested section planes in the current section series.
Created in NX6.0.0.
License requirements : None
numberSectionsRequested | Number of section requested (>= 1). |
void NXOpen::Display::DynamicSectionBuilder::SetOffset | ( | double | offset | ) |
Sets the the plane offset.
When there are more than one clipping planes in the section, the active clipping plane will be not be allowed to cross-over the non-active clipping plane.
If Display::DynamicSectionBuilder::LockPlanes and Display::DynamicSectionBuilder::SetLockPlanes is off, section thickness is updated.
Created in NX5.0.0.
License requirements : None
offset | Offset |
void NXOpen::Display::DynamicSectionBuilder::SetOffsetByPoint | ( | const NXOpen::Point3d & | point | ) |
This method offsets the active clipping plane such that the plane passes through the specified point.
When there are more than one clipping planes in the section, the active clipping plane will be not be allowed to cross-over the non-active clipping plane.
See Display::DynamicSectionBuilder::SetOffset
Created in NX5.0.0.
License requirements : None
point | Point in absolute coordinate system. |
void NXOpen::Display::DynamicSectionBuilder::SetOrigin | ( | const NXOpen::Point3d & | origin | ) |
Sets the section origin.
<br> The section is moved to new location. It obeys the lock flag @link Display::DynamicSectionBuilder::LockPlanes Display::DynamicSectionBuilder::LockPlanes @endlink and @link Display::DynamicSectionBuilder::SetLockPlanes Display::DynamicSectionBuilder::SetLockPlanes @endlink . if it is a multiple plane section. <br> Section offset is updated.
Created in NX5.0.0.
License requirements : None
origin | Section origin |
void NXOpen::Display::DynamicSectionBuilder::SetPlane | ( | const NXOpen::Point3d & | axisOrigin, |
const NXOpen::Point3d & | origin, | ||
const NXOpen::Matrix3x3 & | rotationMatrix | ||
) |
Sets a section plane to be the specified plane The plane is created at the specified origin with the specified rotation matrix.
The axis origin can be same as the plane origin. To defind a linear plane family from the absolute origin, define axis origin as {0, 0, 0}. The section offset will reflect the distance of the plane from the axis origin.
Section offset and rotation matrix are updated.
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::SetPlaneThickness | ( | double | planeThickness | ) |
Sets the thickness between active plane pair.
This property is only available when the section contains more than one clipping plane. When the section planes are locked, setting thickness will not alter the current thickness.
Created in NX5.0.0.
License requirements : None
planeThickness | Active plane thickness |
void NXOpen::Display::DynamicSectionBuilder::SetReverseSeries | ( | bool | reverseSeries | ) |
Sets the reverse series flag
Created in NX6.0.0.
License requirements : None
reverseSeries | reverseseries |
void NXOpen::Display::DynamicSectionBuilder::SetRotationAngle | ( | NXOpen::Display::DynamicSectionTypes::Axis | rotationAxis, |
double | angle | ||
) |
Rotates the section about specified axis by the specified angle.
If a rotation already exists about the specified axis, then the section is rotated such that the total rotation angle is set to the specified angle. Rotation about only one axis is active at a time. @code 1. Create plane with normal along Z. 2. Display.DynamicSectionBuilder.SetRotationAngle( X, 30 ) Rotates plane around X axis by 30 degrees 3. Display.DynamicSectionBuilder.SetRotationAngle( X, 45 ) Incremental rotation of 45 - 30 = 15 degrees. @endcode <br> Section offset and rotation matrix are updated. <br>
Created in NX5.0.0.
License requirements : None
rotationAxis | rotationaxis |
angle | Rotation angle in degrees |
void NXOpen::Display::DynamicSectionBuilder::SetRotationMatrix | ( | NXOpen::Display::DynamicSectionTypes::Axis | rotationAxis, |
const NXOpen::Matrix3x3 & | rotationMatrix | ||
) |
Sets the section rotation matrix
Specify Display::DynamicSectionTypes::AxisNone if the axis about which rotation was performed is not known.
<br> <br> Section offset and rotation matrix are updated. <br>
Created in NX5.0.0.
License requirements : None
rotationAxis | rotationaxis |
rotationMatrix | Rotation matrix |
void NXOpen::Display::DynamicSectionBuilder::SetSeriesSpacing | ( | double | sectionSpacing | ) |
Sets the section plane spacing in the current section series.
Created in NX6.0.0.
License requirements : None
sectionSpacing | Distance between sections (>= 0.02). |
void NXOpen::Display::DynamicSectionBuilder::SetShowCap | ( | bool | showCap | ) |
Sets the cap on off flag
Created in NX5.0.0.
License requirements : None
showCap | showcap |
void NXOpen::Display::DynamicSectionBuilder::SetShowClip | ( | bool | showClip | ) |
Sets the clip on off flag
Created in NX5.0.0.
License requirements : None
showClip | showclip |
void NXOpen::Display::DynamicSectionBuilder::SetShowCurves | ( | bool | showCurves | ) |
Sets the curve on off flag.
<br> When the dynamic section object is visible in the view, the curves from the section object are shown in that view. <br>
Created in NX5.0.0.
License requirements : None
showCurves | showcurves |
void NXOpen::Display::DynamicSectionBuilder::SetShowGrid | ( | bool | showGrid | ) |
Sets the show grid display flag
Created in NX6.0.0.
License requirements : None
showGrid | showgrid |
void NXOpen::Display::DynamicSectionBuilder::SetShowInterference | ( | bool | showInterference | ) |
Sets the interference on off flag.
Created in NX5.0.0.
License requirements : None
showInterference | showinterference |
void NXOpen::Display::DynamicSectionBuilder::SetShowViewer | ( | bool | showViewer | ) |
Sets the 2D viewer display flag
Created in NX6.0.0.
License requirements : None
showViewer | showviewer |
void NXOpen::Display::DynamicSectionBuilder::SetType | ( | NXOpen::Display::DynamicSectionTypes::Type | type | ) |
Sets the section type
Created in NX5.0.0.
License requirements : None
type | type |
void NXOpen::Display::DynamicSectionBuilder::SetView | ( | NXOpen::ModelingView * | view | ) |
Sets the modeling view in which section object edits are being done.
<br> @link Display::DynamicSectionBuilder::SetView Display::DynamicSectionBuilder::SetView@endlink method is present for legacy reasons. Use @link Display::DynamicSectionBuilder::EditView Display::DynamicSectionBuilder::EditView@endlink instead. <br>
Created in NX5.0.0.
License requirements : None
view | Modeling view |
bool NXOpen::Display::DynamicSectionBuilder::ShowCap | ( | ) |
Returns the cap on off flag
Created in NX5.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::ShowClip | ( | ) |
Returns the clip on off flag
Created in NX5.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::ShowCurves | ( | ) |
Returns the curve on off flag.
<br> When the dynamic section object is visible in the view, the curves from the section object are shown in that view. <br>
Created in NX5.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::ShowGrid | ( | ) |
Returns the show grid display flag
Created in NX6.0.0.
License requirements : None
bool NXOpen::Display::DynamicSectionBuilder::ShowInterference | ( | ) |
Returns the interference on off flag.
Created in NX5.0.0.
License requirements : None
void NXOpen::Display::DynamicSectionBuilder::ShowSectionCurves | ( | bool | showCurves | ) |
Shows the section curves in the view associated with the builder.
If no view is associated with the builder, then the curves are Shown in the current work view.
Created in NX7.5.0.
License requirements : None
showCurves | showcurves |
bool NXOpen::Display::DynamicSectionBuilder::ShowViewer | ( | ) |
Returns the 2D viewer display flag
Created in NX6.0.0.
License requirements : None
NXOpen::Display::DynamicSectionTypes::Type NXOpen::Display::DynamicSectionBuilder::Type | ( | ) |
Returns the section type
Created in NX5.0.0.
License requirements : None
NXOpen::ModelingView* NXOpen::Display::DynamicSectionBuilder::View | ( | ) |
Returns the modeling view in which section object edits are being done.
<br> @link Display::DynamicSectionBuilder::SetView Display::DynamicSectionBuilder::SetView@endlink method is present for legacy reasons. Use @link Display::DynamicSectionBuilder::EditView Display::DynamicSectionBuilder::EditView@endlink instead. <br>
Created in NX5.0.0.
License requirements : None